#include "vli.h"
#include "read.h"
#include <istream>
#include <string>
using namespace std;

namespace io {

	bool is_msb_set(uint8_t getal)
	{
		return (getal & (1 << 7));
	}

	void unset_msb(uint8_t *getal)
	{
		*getal &= ~(1UL << 7);
	}

	void accumulate(uint64_t *acc, uint8_t *b)
	{
		*acc = ((*acc) << 7) | (*b);
	}

	uint64_t read_variable_length_integer(std::istream& in)
	{
		uint64_t result = 0;
		uint8_t buffer;
		io::read_to(in, &buffer);

		while (is_msb_set(buffer))
		{
			unset_msb(&buffer);
			accumulate(&result, &buffer);
			io::read_to(in, &buffer);
		}
		unset_msb(&buffer);
		accumulate(&result, &buffer);

		return result;
	}
}