#include "primitives.h"

namespace midi
{
	Duration operator +(const Duration& duration1, const Duration& duration2)
	{
		return Duration(value(duration1) + value(duration2));
	}

	Time operator +(const Time& time, const Duration& duration)
	{
		return Time(value(time) + value(duration));
	}

	Time operator +(const Duration& duration, const Time& time)
	{
		return Time(value(duration) + value(time));
	}

	Duration operator -(const Time& time1, const Time& time2)
	{
		return Duration(value(time1) - value(time2));
	}

	Duration operator -(const Duration& duration1, const Duration& duration2)
	{
		return Duration(value(duration1) - value(duration2));
	}

	Time& operator +=(Time& time, const Duration& duration)
	{
		time = Time(value(time) + value(duration));
		return time;
	}

	Duration& operator +=(Duration& duration1, const Duration& duration2)
	{
		duration1 = Duration(value(duration1) + value(duration2));
		return duration1;
	}

	Duration& operator -=(Duration& duration1, const Duration& duration2)
	{
		duration1 = Duration(value(duration1) - value(duration2));
		return duration1;
	}
}
