#ifndef PRIMITIVES_H
#define PRIMITIVES_H

#include "util/tagged.h"

namespace midi {

	struct __declspec(empty_bases) Channel : tagged<uint8_t, Channel>, equality<Channel>, show_value<Channel, int>
	{
		using tagged::tagged;
	};

	struct __declspec(empty_bases) Instrument : tagged<uint8_t, Instrument>, equality<Instrument>, show_value<Instrument, int>
	{
		using tagged::tagged;
	};

	struct __declspec(empty_bases) NoteNumber : tagged<uint8_t, NoteNumber>, /*equality<NoteNumber>,*/ ordered<NoteNumber>, show_value<NoteNumber, int>
	{
		using tagged::tagged;
	};

	struct __declspec(empty_bases) Time : tagged<uint64_t, Time>, /*equality<Time>,*/ ordered<Time>, show_value<Time, int>
	{
		using tagged::tagged;
	};

	struct __declspec(empty_bases) Duration : tagged<uint64_t, Duration>, /*equality<Duration>,*/ ordered<Duration>, show_value<Duration, int>
	{
		using tagged::tagged;
	};

	Duration operator +(const Duration& duration1, const Duration& duration2);
	Time operator +(const Time& time, const Duration& duration);
	Time operator +(const Duration& duration, const Time& time);
	Duration operator -(const Time& time1, const Time& time2);
	Duration operator -(const Duration& duration1, const Duration& duration2);

	Time &operator +=(Time& time, const Duration& duration);
	Duration &operator +=(Duration& duration1, const Duration& duration2);
	Duration &operator -=(Duration& duration1, const Duration& duration2);
}
#endif // !PRIMITIVES_H
